Bug 7520 - Wrong inode numbers returned
Wrong inode numbers returned
Status: RESOLVED FIXED
Product: CifsVFS
Classification: Unclassified
Component: kernel fs
2.6
x64 Linux
: P3 major
: ---
Assigned To: Jeff Layton
:
Depends on:
Blocks:
  Show dependency treegraph
 
Reported: 2010-06-16 16:15 UTC by Jørgen Thomsen
Modified: 2010-10-12 08:08 UTC (History)
1 user (show)

See Also:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Jørgen Thomsen 2010-06-16 16:15:11 UTC
Observed in Linux Fedora 13.

The cp command will reject copying files because the lstat call returns incorrect inode numbers. strace on the src server on smb displays a correct lstat inode number, but it gets replaced during transit to the destination server.
The problem is intermittent. A repeated command may work.

coreutils-8.5/src/cp: skipping file `/mnt/vl/boot/vmlinuz-2.6.32.12-115.fc12.x86_64', as it was replaced while being copied (dev/ino, lstat 23/5512 fstat 23/21)

The number 5512 is incorrect and from a series of numbers incremented by 1 for each file.

Please, see bug 604089
https://bugzilla.redhat.com/show_bug.cgi?id=604089
Comment 1 Jørgen Thomsen 2010-06-16 16:54:22 UTC
This message was found in dmesg

CIFS VFS: Autodisabling the use of server inode numbers on \\192.168.1.2\rootdir. This server doesn't seem to support them properly. Hardlinks will not be recognized on this mount. Consider mounting with the "noserverino" option to silence this message.

which is nonsense, as it is working many times eg. just by repeating the cp command.
Comment 2 Jeff Layton 2010-07-24 06:06:33 UTC
Does the share you're copying from span multiple filesystems on the server?
Comment 3 Jørgen Thomsen 2010-07-24 10:04:06 UTC
Just simple ext4 setup on both servers
Comment 4 Jeff Layton 2010-07-26 05:36:57 UTC
Can you clarify what you mean by "simple ext4" setup. Are there nested ext4 filesystems under the single share you're mounting?
Comment 5 Jørgen Thomsen 2010-07-29 14:56:00 UTC
Definitely not. I am not running complicated file system setups. It is all plain vanilla one level.
Comment 6 Jeff Layton 2010-07-30 12:24:17 UTC
Ok, I've proposed a set of patches that may help this. Steve French has taken all but one for 2.6.36:

http://article.gmane.org/gmane.linux.file-systems/42531/match=cifs+tighten+up+cifs_iget+matching+criteria

I expect that he'll take the last one eventually, but he hasn't put it in as of yet.
Comment 7 Jeff Layton 2010-09-19 17:32:51 UTC
Steve has taken most of the patches at this point. There's one more that helps prevent inode aliasing by using the CreateTime as an i_generation field that is not yet in.

Jørgen would you be able to test a recent mainline kernel build? What may be simplest is to pull down the latest Fedora rawhide kernel out of koji and test that.
Comment 8 Jørgen Thomsen 2010-09-19 17:59:19 UTC
Sorry, no. I neither have the test facilities nor the time to spend on beta kernels and have no idea what koji is.
Comment 9 Jeff Layton 2010-10-12 08:08:59 UTC
Fair enough then. Closing this bug as FIXED in kernel 2.6.36. Please reopen if you find that it isn't.